/* au file ôʬΥإåե
 * shige
 * 05/29 2000
 * auio.h
 * 
 * $Id: auio.h,v 1.18 2017-03-09 17:17:40+09 shige Exp $
 */
#ifndef __AUIO_H__
#define __AUIO_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include "error.h"
#include "fileio.h"
#include "g711.h"
#include "cstruct.h"

typedef struct {
    long int magic;	/* magic number AU_MAGIC */
    long int hlen;	/* data  offset */
    long int datalen;	/* data Ĺ */
    long int fmcode;	/* data format code */
    long int smplrate;	/* sampling rate */
    long int channel;	/* channel  */
    char *str;	/* Ǥդʸ */
} AUdata;

/* ̵ǡ */
#define AUNULL (0x7e)
/* AUSCALE: |粻|
 */
#define AUSCALE 32124.0

#define AUMAXChannel 50

/* for chSndheaderMASK() */
#define AU_MAGIC	0x0001
#define AU_FMCODE	0x0002
#define AU_CHANNEL	0x0004
#define AU_SMPLRATE	0x0008

#ifdef __AUIO_C__
# define EXTERN_AUIO 
#else
# define EXTERN_AUIO extern 
#endif

EXTERN_AUIO int getAUheader(FILE *file, AUdata *aud, int mode);
#if 0
EXTERN_AUIO int getAUheader(FILE *file, AUdata *aud);
EXTERN_AUIO int getAUheader_noseek(FILE *file, AUdata *aud);
EXTERN_AUIO int getAUheader_noseek2(FILE *file, AUdata *aud);
#endif
EXTERN_AUIO int chAUheader(AUdata *aud1, AUdata *aud2);
EXTERN_AUIO int chAUheaderMASK(AUdata *aud1, AUdata *aud2,
				 int mask);
EXTERN_AUIO void putAUheader(FILE *file, AUdata *aud);
#endif /* __AUIO_H__ */
