/* 8bit u-law / 8kHz  data ñ˷Ҥ
 * shige
 * 02/16 1999 ver 0.1
 * 03/09 1999 ver 0.2
 * 05/02 2000 ver 0.3
 * auconn.c
 *
 * $Id: auconn.c,v 1.31 2007-02-09 17:15:13+09 shige Exp $
 */
/* 02/16 1999
 * 1)	椯椯ϿʤΤĤʤѤˤ
 * 03/09 1999
 * 2)	file  full path ͿƤȤ shell  command line 
 * 	buffer θ³롣äơsearch path ꤹ褦ˤ롣
 * 	ϡ file  path Ǥʤdata format ʤɿ 
 *	command line option 񤱤褦ˤ롣ޤǳĥ
 *	ʤ
 * 05/02 2000
 * 3)	strtok  csrc/test/teststrt.c ˤ⤢褦ˡconstant ʸ
 *	ФƤ Bus error
 */
#ifndef __AUCONN_C__
#define __AUCONN_C__

#include "auconn.h"

/* ########## main routine ########## */
int main(int argc,char *argv[],char *env[])
{
    int j,k;
    SNDheader *snd;
    int dataonly=0,ret;
    int Nlen,olen,bs,ch,byte,blocks,len,addsp;
    double smplrate;
    double times;
    int form;
    ConnOpt opt[Maxdatanum];
    int fnamepos[Maxdatanum];
    int ordermode[Maxdatanum],orderparam[Maxdatanum],pathnum[Maxdatanum];
    int fnames,nullexist,nullpathnum;

    if((form=setdefaultSndForm(argv[0]))==E_UNKNOWN){
	usage(argv[0],form); return Exit_noarg;
    }
    initdefvar(form);
    if(argc<2){ usage(argv[0],form); return Exit_noarg; }
    if((fnames=getarg(argc,argv,env,&dataonly,fnamepos,opt,ordermode,
		      orderparam))<=0){
	usage(argv[0],form); return -fnames;
    }
#ifdef DEBUG4
    fprintf(stderr,"[debug4] fnames=%d\n",fnames);
    for(j=1;j<=fnames;j++){
	fprintf(stderr,"[debug4] fnamepos[%d]=%d (%s)\n",j-1,fnamepos[j-1],
		argv[fnamepos[j-1]]);
	fprintf(stderr,"[debug4] ordermode[%d]=%d\n",j-1,ordermode[j-1]);
    }
#endif
    if(listonly){
	for(j=1;j<=fnames;j++)
	  if((tmpfile1=fopenpathlist(argv[fnamepos[j-1]],ordermode[j-1],
				     orderparam[j-1],NULL))!=NULL
	     ||(NULLFname!=NULL 
		&& (tmpfile1=fopenpathlist(NULLFname,ordermode[j-1],
					   orderparam[j-1],NULL))!=NULL))
	    fclose(tmpfile1);
	return No_err;
    }
    if(NULLFname!=NULL 
       && (tmpfile1=fopenpathlist(NULLFname,0,0,&nullpathnum))!=NULL){
	nullexist=1;
	fclose(tmpfile1);
    }
    else nullexist=0;

    /* 1 ܤ file 򳫤 */
    if((tmpfile1=fopenpathlist(argv[fnamepos[0]],ordermode[0],
			       orderparam[0],&pathnum[0]))==NULL){
	if(!nullexist) return Exit_openpathfile;
	argv[fnamepos[0]]=NULLFname; 
	if((tmpfile1=fopenpathlist(argv[fnamepos[0]],ordermode[0],
				   orderparam[0],&pathnum[0]))==NULL)
	  return Exit_openpathfile;
    }
    if((snd=(SNDheader *)malloc(sizeof(SNDheader)*fnames))==NULL) 
      return Exit_getmaxdata;
    if((ret=getSNDheader(tmpfile1,&snd[0]))<0 || ret!=form)
      return Exit_getSndheader;
    /* opt[].len Ѵ */
    smplrate=SNDsmplrate(&snd[0],form);
    for(j=1;j<=fnames;j++)
      if(opt[j-1].block==0 && opt[j-1].len>0) 
	opt[j-1].len=opt[j-1].len*smplrate/1000;
    fclose(tmpfile1);
    /* 2 ܰʹߤ file 򳫤 header  1 ܤΤΤ */
    for(j=2;j<=fnames;j++){
	if((tmpfile1=fopenpathlist(argv[fnamepos[j-1]],ordermode[j-1],
				   orderparam[j-1],&pathnum[j-1]))==NULL){ 
	    if(!nullexist) return Exit_openpathfile;
	    argv[fnamepos[j-1]]=NULLFname;
	    if((tmpfile1=fopenpathlist(argv[fnamepos[j-1]],ordermode[j-1],
				       orderparam[j-1],&pathnum[j-1]))==NULL)
	      return Exit_openpathfile;
	}
	if(getSNDheader(tmpfile1,&snd[j-1])<0)
	  return Exit_getSndheader;
	if(SNDchheaderMASK(&snd[j-1],&snd[0],form,CH_ALL)<0)
	  return Exit_chSndheader;
	fclose(tmpfile1);
    }
    /*  */
    if(!dataonly) putallSNDheaderOpt(stdout,snd,fnames,opt,form);
    bs=SNDblocksize(&snd[0],form);
    ch=SNDchannels(&snd[0],form);
    byte=bs/ch;
    for(j=1;j<=fnames;j++){
	if((tmpfile1=fopenpathlist(argv[fnamepos[j-1]],-1,0,
				   &pathnum[j-1]))==NULL)
	  return Exit_openpathfile;
	Nlen=SNDdatalen(&snd[j-1],form)/bs;
	len=opt[j-1].len;
	addsp=opt[j-1].addsp;
	times=opt[j-1].times;
	if(times>0.0 && times!=1.0) Nlen=Nlen/times;
	olen=(len>0 && len<Nlen)? len : Nlen;
	if(len>0 && Nlen<len && addsp<0){
	    blocks=(len-Nlen)*ch;
	    for(k=1;k<=blocks;k++) SNDputnull1ch(stdout,&snd[j-1],form);
	}
	/* Ѵ (len>0 => min{Nlen,len}, len<0 => Nlen) */
	SNDputtrans(tmpfile1,stdout,&snd[j-1],form,olen,times);
	if(len>0 && Nlen<len && addsp>0){
	    blocks=(len-Nlen)*ch;
	    for(k=1;k<=blocks;k++) SNDputnull1ch(stdout,&snd[j-1],form);
	}
	fclose(tmpfile1);
	tmpfile1=NULL;
    }
    return No_err;
}

#if 0
/* Ϲ¤ΤΥԡϴñˤǤ */
void cpConnOpt(ConnOpt *new,ConnOpt *org)
{
    new->addsp=org->addsp;
    new->block=org->block;
    new->len=org->len;
    new->times=org->times;
}
#endif

/* ########## get-argument and initialize for {au,wav,aiff}conn ########## */
int setdefaultSndForm(char *commname)
{
    int len1,len2,j;

    len1=strlen(commname);
    for(j=0;j<=2;j++){
        if((len2=strlen(CommandNames[j]))<=len1){
            if(len2==len1 && strcmp(CommandNames[j],commname)==0) return j;
            if(len2<len1 && strcmp(CommandNames[j],commname+len1-len2)==0
                && *(commname+len1-len2-1)=='/') return j;
        }
    }
    return E_UNKNOWN;
}

/* fopenpathlist()  mode ϡ
 *   mode=0: ʤ
 *   mode=1: ȥ졼
 *   mode=2: random 
 *   mode=3: param Ƭ
 *   mode=4: param ܤΤ
 * ʤΤǡ
 *   (-P ꤬ʤ && -Pr2 Ǥʤ) ==> mode=0
 *   (-P ꤬ʤ && -Pr2) ==> mode=2
 *   (-P ꤬) ==>  (mode=1,2,3,4)
 * ȤФĤޤꡢPr2 ݻ global mode ѿѰդФ
 */
int getarg(int argc,char *argv[],char *env[],int *dataonly,
	   int fnamepos[],ConnOpt opt[],int omode[],int oparam[])
{
    int j=1,inoption,ret;
    char c;
    int filenum=1,pr2f=0;

    inithome(env);
    undefs="undefined"; NULLFname=undefs;
    opt[filenum-1].addsp=0;
    opt[filenum-1].block=0;
    opt[filenum-1].len=-1;
    opt[filenum-1].times=-1.0;
    omode[filenum-1]=0;
    oparam[filenum-1]=0;
    while(1){
	if(*argv[j]!='-'){
	    fnamepos[filenum-1]=j;
	    if(++j>=argc) break;
	    if(++filenum>Maxdatanum) return -Exit_toomanyarg;
	    opt[filenum-1]=opt[filenum-2];
	    if(pr2f) omode[filenum-1]=2;
	    else omode[filenum-1]=0;
	    oparam[filenum-1]=0;
	    continue;
	}
	c=*(++argv[j]);
	while(1){
	    switch(c){
	    case 'p':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if(addstr2pathlist(argv[j])<0) return -Exit_addstr2pathlist;
		inoption=0;
		break;
	    case 'e':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if(addstr2extlist(argv[j])<0) return -Exit_addstr2extlist;
		inoption=0;
		break;
	    case 'f':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		DEFAULTConffname=argv[j];
#if 0
		if(addfile2list(argv[j])<0) return -Exit_addfile2list;
#endif /* 0 */
		inoption=0;
		break;
	    case 'q':
		verbose=0;
		inoption=1;
		break;
	    case 'l':
		listonly=1;
		inoption=1;
		break;
	    case 'r':
		*dataonly=1;
		inoption=1;
		break;
	    case 'n':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if(*argv[j]=='-') NULLFname=NULL;
		else NULLFname=argv[j];
		inoption=0;
		break;
	    case 'i':
		if(*++argv[j]=='\0') DEFAULTPathlist=DEFAULTExtlist=NULL;
		else if(*argv[j]=='e') DEFAULTExtlist=NULL;
		else if(*argv[j]=='p') DEFAULTPathlist=NULL;
		else return -Exit_invalid_arg;
		inoption=0;
		break;
	    case 'L':
		if((ret=getL(argc,argv,&j,&opt[filenum-1]))<0) return ret;
		inoption=0;
		break;
	    case 'S':
		if(*++argv[j]=='\0' && ++j>=argc) return -Exit_noarg;
		if((opt[filenum-1].times=atof(argv[j]))<Mintimes) 
		  return -Exit_invalid_arg;
		inoption=0;
		break;
	    case 'P':
		ret=getP(argc,argv,&j,&omode[filenum-1],&oparam[filenum-1]);
		if(ret<0) return ret;
		if(omode[filenum-1]==2 && oparam[filenum-1]==2) pr2f=1;
		else pr2f=0;
		inoption=0;
		break;
	    case 'h':
		return -Exit_help;
	    default:
		return -Exit_unknownarg;
	    }
	    if(!inoption ||(c=*(++argv[j]))=='\0') break;
	}
	if(++j>=argc) return -Exit_noarg;
    }
    if(initpathextlist(env)!=No_err) return -Exit_envdefault;
    /* option ˤäƤ file ̾ stdin 餦äƤΤ⤤⤷
     * ʤ
     */
#ifdef DEBUG4
    putallpathlist();
    putallextlist();
#endif
    return filenum;
}

void initdefvar(int format)
{
    if(format==E_AU){
	DEFAULTExtlist=AU_Extlist;
	DEFAULTPathlist=AU_Pathlist;
	DEFAULTConffname=AU_Conffname;
	DEFAULTExtEnvname=AU_ExtEnvname;
	DEFAULTPathEnvname=AU_PathEnvname;
	DEFAULTNULLFEnvname=AU_NULLFEnvname;
    }
    else if(format==E_WAV){
	DEFAULTExtlist=WAV_Extlist;
	DEFAULTPathlist=WAV_Pathlist;
	DEFAULTConffname=WAV_Conffname;
	DEFAULTExtEnvname=WAV_ExtEnvname;
	DEFAULTPathEnvname=WAV_PathEnvname;
	DEFAULTNULLFEnvname=WAV_NULLFEnvname;
    }
    else if(format==E_AIFF){
	DEFAULTExtlist=AIFF_Extlist;
	DEFAULTPathlist=AIFF_Pathlist;
	DEFAULTConffname=AIFF_Conffname;
	DEFAULTExtEnvname=AIFF_ExtEnvname;
	DEFAULTPathEnvname=AIFF_PathEnvname;
	DEFAULTNULLFEnvname=AIFF_NULLFEnvname;
    }
}

/* ##### -P option ؿ ##### */
int getP(int argc,char *argv[],int *j,int *Omode,int *Oparam)
{
    int k;
    char c;

    if((c=*++argv[*j])=='\0') return -Exit_noarg;
    if(*++argv[*j]=='\0' && ++*j>=argc) return -Exit_noarg;
    if((k=atoi(argv[*j]))<0) return -Exit_invalid_arg;
    if(c=='r'){ /* random ⡼ */
	if(k==0){ *Omode=1; *Oparam=0; return No_err; }
	else if(k==1){ *Omode=2; *Oparam=1; return No_err; }
	else if(k==2){ *Omode=2; *Oparam=2; return No_err; }
	else return -Exit_invalid_arg;
    }
    else if(c=='s'){ /* swap ⡼ */
	if(k==0) return -Exit_invalid_arg;
	else{ *Omode=3; *Oparam=k; return No_err; }
    }
    else if(c=='o'){ /* ñȻ⡼ */
	if(k==0) return -Exit_invalid_arg;
	else{ *Omode=4; *Oparam=k; return No_err; }
    }
    else return -Exit_invalid_arg;
}

/* ##### -L option ؿ ##### */
int getL(int argc,char *argv[],int *j,ConnOpt *opt)
{
    int k;

    if(*++argv[*j]=='b') opt->block=1;
    else if(*argv[*j]=='s') opt->block=0;
    else return -Exit_invalid_arg;

    if(*++argv[*j]=='\0' && ++*j>=argc) return -Exit_noarg;
    if((k=strlen(argv[*j]))<=0) return -Exit_invalid_arg;

    if(*(argv[*j]+k-1)=='+'){ opt->addsp=1; *(argv[*j]+k-1)='\0'; }
    else if(*(argv[*j]+k-1)=='-'){ opt->addsp=-1; *(argv[*j]+k-1)='\0'; }
    else opt->addsp=0;

    if((opt->len=atoi(argv[*j]))<=0) return -Exit_invalid_arg;
    return No_err;
}

/* ##### usage() for {au,aiff,wav}conn ##### */
void usage(char *comname,int form)
{
    char *fs[]={"au","wav","aiff"};
    char *mess[]={
	"Usage: %s [options] [%sfile] ([%sfile] ...)",
	" options:",
	"   -p[path]: %s file ѥ",
	"             (default=\"%s\")",
	"   -e[ext] : %s file ĥ",
	"             (default=\"%s\")",
	"   -f[file]: ե (default=%s)",
	"   -l      : %s file ΥꥹȤΤɽ",
	"   -n[path]: nullfile ե̾ (default=ʤ)",
	"   -L[str] : ƲǤĹ (default=ĹϹͤˤĤʤ)",
	"             ([str] = (b|s)[Ĺ](+|-))",
	"   -S[num] : [num] ® (default=1.0)",
	/* "   -au/wav/aiff: եޥåȤλ", */
	"   -r      : եإåϤʤ (default=Ϥ)",
	"   -P(r|s|o)[n]: ѥθ (default=)",
	"   -i(p|e|): ǥեȤθѥꥹ/ĥҥꥹȤ̵ˤ",
	"   -q      : 顼ɽʤ",
	"   -h      : Υå",
	" ",
	" [1] ѥĥҤϡ (':') ǥߥȤʣǤ롣",
	" [2] եˤϡǥեȤθѥĥҤǤ롣",
	"     եǤ '#' ǻϤޤԤϥȤȸʤ졢Ԥ"
	"̵뤵롣",
	"     ԤΥեޥåȤ",
	"       [] [ꥹ]",
	"     Ǥꡢ[] ϸѥ \"path\", ĥҤ \"ext\" Ȥ롣",
	"     եǤ ':' ͭĹʤϡƱ"
	"ʣ",
	"     Ԥ񤱤Ф褤",
	" [3] ѥĥҤϡ줾Ķѿ %s"
	", %s ⻲Ȥ롣",
	"     ̤ͥ",
	"       ޥɥ饤 > Ķѿ > ե > ǥե",
	"     ν (ǥեȤϥѥΥǥեȤǡ"
	"ץ",
	"     βս default: Ȥƽ񤫤Ƥ)",
	" [4] nullfile ϡꤷե뤬ʤäѤ˻"
	"ե",
	"     (̵ʤ)ΥեФƤ⸡ѥĥҤ"
	"ͭ",
	"     default Ǥ nullfile ϻѤ顼Ȥ롣"
	"Ķѿ %s Ǥ",
	"     ꡢեǤΥ \"nullfile\" ˤġ",
	"     ʤե̾Ȥ \"-\" ꤷ nullfile "
	"Ѥʤ",
	" [5] -L[str] ꤹȡƲǤꤷĹ·ƽϤ롣"
	"[str] ",
	"       b[num],b[num]+,b[num]-(==[num] block)",
	"       s[num],s[num]+,s[num]-(==[num] ߥ)",
	"      6 ̤ηǻǤ롣ǤĹĹĹ"
	"åȤ졢",
	"     Ĺû '+', '-' ǸˤĤƤ̵"
	"ʬä",
	"     ('+': ̵, '-': Ƭ̵) ŪĹ [num]"
	"·롣",
	" [6] -S[num]  [num]>1.0 ΤȤ®[num]<1.0 ΤȤ٤"
	"ꡢ",
	"     ˱ƲѲ롣",
	" [7] -P λϰʲ̤ꡣ",
	"       -Pr[n]:  (n=0: , 1: 硢2: "
	")",
	"       -Ps[n]: ͥ (n ܤλѥͥ˸)",
	"       -Po[n]: ñȻ (n ܤλѥΤߤ򸡺)",
	" [8] -L/-S/-P ץϡե (ʣ) ꤹ"
	"뤳Ȥ",
	"     Ǥξ礽ϤʹߤΥե˱ƶ롣",
	" [9] -i ץϡ-ie ξϥǥեȤγĥҥꥹȤ̵"
	"ˤ",
	"     -ip ξǥեȤθѥꥹȤ̵ˡ-i ξξ"
	"̵",
	NULL
    };
    int j;

    if(form==E_UNKNOWN) form=0;
    for(j=0;mess[j]!=NULL;j++){
	if(j==0) fprintf(stderr,mess[j],comname,fs[form],fs[form]);
	else if(j==2 || j==4 || j==7) fprintf(stderr,mess[j],fs[form]);
	else if(j==3) fprintf(stderr,mess[j],StrOrNull(DEFAULTPathlist));
	else if(j==5) fprintf(stderr,mess[j],StrOrNull(DEFAULTExtlist));
	else if(j==6) fprintf(stderr,mess[j],StrOrNull(DEFAULTConffname));
	else if(j==24) 
	  fprintf(stderr,mess[j],StrOrNull(DEFAULTPathEnvname),
		  StrOrNull(DEFAULTExtEnvname));
	else if(j==31) fprintf(stderr,mess[j],StrOrNull(DEFAULTNULLFEnvname));
	else fprintf(stderr,mess[j]);
	fputc('\n',stderr); 
    }
}

#endif /* __AUCONN_C__ */
