/* ƬФ tool ѥإåե
 * funa@nolm01.iee.niit.ac.jp, shige
 * 02/24 2001
 * sndslcut.h
 *
 * $Id: sndslcut.h,v 1.4 2017-03-17 16:26:19+09 shige Exp $
 */
#ifndef __SNDSLCUT_H__
#define __SNDSLCUT_H__

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#include "cstruct.h"
#include "common.h"

/* ##### ¤ ##### */
typedef struct {
    /* On/Off flag */
    int usegraph;	/* դɤ */
    int usesound;	/* Ĥ餹ɤ */
    int putkey;		/* ɽ뤫ɤ */
    int forward;	/* Ǹ/Ƭؤβ */
    int verbose;	/* Ĺ */
    int usemsec;	/* ñ̤ϥߥ/֥å */
    /* number value */
    int divide;		/* ʬ (default 3) */
    SndLen minlen;	/* ʬǾĹ */
    SndLen sndlen;	/* ʬĹ */
    int ch;		/* ͥ */
    /* ʸ */
    char *outfname;	/* ϥե̾ */
    char *infname;	/* ϥե̾ */
    char *tmpd;		/* ȥǥ쥯ȥ̾ */
    char *poofname;	/* ñ㲻ե̾ */
    char *playcmd;	/* ޥ */
    /* ȤǷ */
    int form;		/*  */
    SNDheader snd;		/* ϥǡβإå */
    long int datapos;	/* ǡƬ */
} Opt;

/* ########## macros ########## */

/* ʸ󥪥ץ */
enum Options { 
    SOP_UNKNOWN = 0, SOP_O, SOP_TMP, SOP_SH, SOP_SN, SOP_SP 
};

#define MaxBuff 800
#define MaxLevel 20
#define MaxDivide 9

#define FPUT0(s) fprintf(stderr, (s))
#define FPUT1(s, a) fprintf(stderr, (s), (a))
#define FPUT2(s, a, b) fprintf(stderr, (s), (a), (b))
#define FPUT3(s, a, b, c) fprintf(stderr, (s), (a), (b), (c))
#define FPUT4(s, a, b, c, d) fprintf(stderr, (s), (a), (b), (c), (d))

#define STRORNULL(s) ((s) != NULL ? (s) : "(null)")
#define is1cop(c) ((c) == 'v' || (c) == 'k' || (c) == 'e' \
	|| (c) == 'b' || (c) == 'g' || (c) == 'a')

/* ##### Default values ##### */
/* ʲɬפʤĶ˹碌ƽΤȡ*/
#ifdef USEPLOT
# define Default_Usegraph 1
#else
# define Default_Usegraph 0
#endif
#ifdef USESOUND
# define Default_Usesound 1
#else
# define Default_Usesound 0
#endif
#define Default_Putkey 0
#define Default_Forward 1
#define Default_Verbose 0
#define Default_Usemsec 1
#define Default_Divide 3
#define Default_Minlen 1L
/* ms ñ̡ñ̤ block ξϤѴ */
#define Default_Sndlen 500L
/* ms ñ̡ñ̤ block ξϤѴ */
#define Default_Channel 0
#define Default_Tmpd "/tmp"
#define Default_Poofname "poo"

#define lint45(x) ((long int) ((x) + 0.5))
#define ms2bk(n, smpl) (lint45((double) (n)*(smpl)/1000.0))
#define bk2ms(n, smpl) (lint45((double) (n)*1000.0/(smpl)))

#define Dbk2ms(n, smpl) ((double) (n)*1000.0/(smpl))


#ifndef GNUPLOT
# define GNUPLOT "gnuplot"
#endif

#ifndef AUCONN
# define AUCONN "auconn"
#endif
#ifndef WAVCONN
# define WAVCONN "wavconn"
#endif
#ifndef AIFFCONN
# define AIFFCONN "aiffconn"
#endif

#ifndef AUPLAY
# define AUPLAY "| auplay"
/* On Solaris */
/* #define AUPLAY "| cat | /bin/audioplay -" */
#endif
#ifndef WAVPLAY
# define WAVPLAY "| wavplay"
#endif
#ifndef AIFFPLAY
# define AIFFPLAY "| aiffplay"
#endif

/* ##### ѿ ##### */
char *sndconn[] = { AUCONN, WAVCONN, AIFFCONN };
char *sndext[] = { "au", "wav", "aiff" };
char *sndplay[] = { AUPLAY, WAVPLAY, AIFFPLAY };
char *TempFnameHead = "sndslcut-";

/* ########## prototype declaration ########## */
int main(int argc, char *argv[]);
void atlast(Opt *opt, FILE *infile, long int cblock, int level,
	    long int ctop[], long int clast[], int cpos[],
	    char tmpfnames[][MaxBuff]);
void puthistory(Opt *opt, long int cblock, int level, long int ctop[],
		long int clast[], int cpos[]);
int outputresult(Opt *opt, FILE *infile, long int cblock);
int posup(Opt *opt, long int pos[], long int ctop[], long int clast[],
	  int cpos[], int key, int *Level);
int setpos(long int pos[], int divide, long int ctop, long int clast,
	   long int minsize);
int getkey(int putkey, int divide);
void putsndgraph(Opt *opt, FILE *infile, long int pos[],
		 char tmpfnames[][MaxBuff], int isposup);
void putsound(Opt *opt, FILE *infile, long int pos[],
	      char tmpfnames[][MaxBuff], int isposup);
void mkconnsnd(Opt *opt, char tmpfnames[][MaxBuff]);
int mksubsnd(Opt *opt, FILE *infile, long int pos, long int sndlen,
	      char *outfname);
int putgraph(Opt *opt, FILE *infile, long int pos[], int isposup, 
	      int mode);
void setgraph(FILE *gp, Opt *opt, long int pos[]);
void putopt(Opt *opt);
void setdefault(Opt *opt);
int arganal(int argc, char *argv[], Opt *opt, char **Minlenstr,
	    char **Sndlenstr);
int setinit(Opt *opt, char tmpfnames[][MaxBuff],
	    FILE **Infile, char *MinLenstr, char *SndLenstr);
int setSndLen(SndLen *sndlen, char *lenstr, int usemsec, double smpl);
void mktmpfnames(int divide, char *tmpd, char *ext, 
		 char tmpfnames[][MaxBuff]);
void usage(char *name);

#endif /* __SNDSLCUT_H__ */
